/* player.c */

#include <sys/iocs.h>
#include <xsp2lib.h>

#include "main.h"
#include "player.h"
#include "shot.h"

#define PLAYER_BANK1	8	/* Xp^[ֈڍs܂ł̒l */
#define PLAYER_BANK2	12	/* ԌXp^[ֈȉ */

#define PLAYER_SPEED	15	/* @̑x */
#define PLAYER_PALET	0x0700	/* @̃pbg */

#define PLAYER_START_X	144	/* @o̍W */
#define PLAYER_START_Y	(256+32)


enum {
	PLAYER_PT_RIGHT2 = 0,	/* @ԉEɌXĂ鎞̃p^[ */
	PLAYER_PT_RIGHT1,	/* @V@EɁ@@@@@V@@@@@ */
	PLAYER_PT_CENTER,	/* @V@ʂĂ鎞̃p^[ */
	PLAYER_PT_LEFT1,	/* @EɌXĂ鎞̃p^[ */
	PLAYER_PT_LEFT2		/* @V@ԉEɁ@@@@@V@@@@@ */
};



/* Q[JnɌĂ΂ */
void PlayerInit (void)
{
}



/* vC[oɌĂ΂ */
void PlayerAlloc (void)
{
	player->lx = PLAYER_START_X * 65536;
	player->ly = PLAYER_START_Y * 65536;
	player->status = PLAYER_STATUS_APPEAR;	/* oԂ */
}



/* @Ă鎞̈ړ */
static void PlayerMoveAlive (void)
{
	int j;			/* WCXeBbN̓ */

	j = _iocs_joyget (0);	/* WCXeBbNO */

	/* [A] {^ꂽH */
	if ((j & 0b00100000) == 0)
		game_over = !0;	/* Q[I[o[ */

	/* [B] {^ꂽH */
	if ((j & 0b1000000) == 0)
		ShotAlloc ();

	/* @̏㉺ړ */
	switch (j & 0b0011) {
	case 0b0010:		/*  */
		player->ly += xytable[PLAYER_SPEED][192].y;
		break;
	case 0b0001:		/*  */
		player->ly += xytable[PLAYER_SPEED][64].y;
		break;
	default:		/* ȊO */
		break;
	}

	/* @̍Eړ{EX */
	switch (j & 0b1100) {
	case 0b1000:		/*  */
		player->lx += xytable[PLAYER_SPEED][128].x;
		if (player->bank > 0) {
			player->bank = 0;
		} else {
			if (player->bank > -PLAYER_BANK2)
				player->bank--;
		}
		break;

	case 0b0100:		/* E */
		player->lx += xytable[PLAYER_SPEED][0].x;
		if (player->bank < 0) {
			player->bank = 0;
		} else {
			if (player->bank < PLAYER_BANK2)
				player->bank++;
		}
		break;

	default:		/* ȊO */
		/* @̌Xɖ߂ */
		if (player->bank != 0) {
			if (player->bank > 0)
				player->bank--;
			else
				player->bank++;
		}
		break;
	}

	/* @̌X (player->bank) 玩@̕XvCgNo.߂ */
	if (player->bank == 0) {
		player->pt = obj_player + PLAYER_PT_CENTER;
	} else {
		if (player->bank > 0) {
			if (player->bank < PLAYER_BANK1)
				player->pt = obj_player + PLAYER_PT_LEFT1;
			else
				player->pt = obj_player + PLAYER_PT_LEFT2;
		} else {
			if (player->bank > -PLAYER_BANK1)
				player->pt = obj_player + PLAYER_PT_RIGHT1;
			else
				player->pt = obj_player + PLAYER_PT_RIGHT2;
		}
	}

	player->x = player->lx / 65536;
	player->y = player->ly / 65536;

	xobj_set (player->x, player->y, player->pt, PLAYER_PALET | PRIORITY_PLAYER);	/* @\ */
}


/* @񂾎̈ړ */
static void PlayerMoveDead (void)
{
	/* W */
	player->lx = PLAYER_START_X * 65536;
	player->ly = PLAYER_START_Y * 65536;
	player->status = PLAYER_STATUS_APPEAR;	/* oԂ */
}



/* @񂾌̓oꏈ */
static void PlayerMoveAppear (void)
{
	player->bank = 0;
	player->pt = obj_player + PLAYER_PT_CENTER;
	player->ly -= (4 * 65536);

	player->x = player->lx / 65536;
	player->y = player->ly / 65536;

	/* @x܂Ői񂾂ʏԂ */
	if (player->y < 160)
		player->status = PLAYER_STATUS_ALIVE;

	xobj_set (player->x, player->y, player->pt, PLAYER_PALET | PRIORITY_PLAYER);	/* @\ */
}



/* ƂɌĂ΂ */
void PlayerMove (void)
{
	switch (player->status) {
	case PLAYER_STATUS_ALIVE:
		PlayerMoveAlive ();
		break;
	case PLAYER_STATUS_DEAD:
		PlayerMoveDead ();
		break;
	case PLAYER_STATUS_APPEAR:
		PlayerMoveAppear ();
		break;
	}
}
